com.dlsc.flexgantt.swing.selector

## Class ColumnChooserSelector

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Window
      - - javax.swing.JWindow
        - - com.dlsc.flexgantt.swing.selector.Selector
          - - com.dlsc.flexgantt.swing.selector.ColumnChooserSelector

- All Implemented Interfaces:
    MouseListener, MouseMotionListener, ImageObserver, LayoutManager, MenuContainer, Serializable, EventListener, Accessible, RootPaneContainer

      public class ColumnChooserSelector
      extends Selector
      implements MouseListener, MouseMotionListener

  A selector that wraps a control for editing the list of used columns in the tree table of a Gantt chart. The control displays the list of available columns and the list of used columns and it allows the user to move columns from one list to another. The order of the used columns can also be changed.

  This selector is a little bit different than the other selectors because it supports resizing. The user can drag a resize corner in the lower right corner of the selector window to change the selector's size.

  Since:
    1.0
  Version:
    $Revision: 1.8 $
  Author:
    Dirk Lemmermann
  See Also:
    `ColumnChooser`, Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.dlsc.flexgantt.swing.selector.Selector

      `Selector.Location`

    - ### Nested classes/interfaces inherited from class javax.swing.JWindow

      `JWindow.AccessibleJWindow`

    - ### Nested classes/interfaces inherited from class java.awt.Window

      `Window.AccessibleAWTWindow, Window.Type`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JWindow

      `accessibleContext, rootPane, rootPaneCheckingEnabled`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ColumnChooserSelector(JComponent parentComponent, AbstractGanttChart gc)` Constructs a new column chooser selector.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `JPanel` | `getButtonPanel()` Returns the button panel that contains the close button.
    `JButton` | `getCloseButton()` Returns the button for closing the selector.
    `ColumnChooser` | `getColumnChooser()` Returns the column chooser.
    `JPanel` | `getContentPanel()` Returns the panel that contains the chooser and the footer.
    `JLabel` | `getResizeIconLabel()` Returns the label that is used for resizing the selector.
    `void` | `mouseClicked(MouseEvent e)`
    `void` | `mouseDragged(MouseEvent e)`
    `void` | `mouseEntered(MouseEvent e)`
    `void` | `mouseExited(MouseEvent e)`
    `void` | `mouseMoved(MouseEvent e)`
    `void` | `mousePressed(MouseEvent e)`
    `void` | `mouseReleased(MouseEvent e)`
    `void` | `setVisible(boolean b)` Overrides the method in order to update the two column lists first before proceeding to actually display the selector.

    - ### Methods inherited from class com.dlsc.flexgantt.swing.selector.Selector

      `addLayoutComponent, getCloseSelectorLabel, getContentComponent, getFooterPanel, getGlobalAnimationDuration, getHeaderPanel, getParentComponent, getSelectorLocation, getTitleLabel, isAnimationEnabled, isAutoHideEnabled, isGlobalAnimationEnabled, isGlobalAutoHideEnabled, layoutContainer, minimumLayoutSize, preferredLayoutSize, removeLayoutComponent, setAnimationEnabled, setAutoHideEnabled, setContentComponent, setGlobalAnimationDuration, setGlobalAnimationEnabled, setGlobalAutoHideEnabled`

    - ### Methods inherited from class javax.swing.JWindow

      `addImpl, createRootPane, getAccessibleContext, getContentPane, getGlassPane, getGraphics, getLayeredPane, getRootPane, getTransferHandler, isRootPaneCheckingEnabled, paramString, remove, repaint, setContentPane, setGlassPane, setLayeredPane, setLayout, setRootPane, setRootPaneCheckingEnabled, setTransferHandler, update, windowInit`

    - ### Methods inherited from class java.awt.Window

      `addNotify, addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, applyResourceBundle, applyResourceBundle, createBufferStrategy, createBufferStrategy, dispose, getBackground, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getIconImages, getInputContext, getListeners, getLocale, getModalExclusionType, getMostRecentFocusOwner, getOpacity, getOwnedWindows, getOwner, getOwnerlessWindows, getShape, getToolkit, getType, getWarningString, getWindowFocusListeners, getWindowListeners, getWindows, getWindowStateListeners, hide, isActive, isAlwaysOnTop, isAlwaysOnTopSupported, isAutoRequestFocus, isFocusableWindow, isFocusCycleRoot, isFocused, isLocationByPlatform, isOpaque, isShowing, isValidateRoot, pack, paint, postEvent, processEvent, processWindowEvent, processWindowFocusEvent, processWindowStateEvent, removeNotify, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, reshape, setAlwaysOnTop, setAutoRequestFocus, setBackground, setBounds, setBounds, setCursor, setFocusableWindowState, setFocusCycleRoot, setIconImage, setIconImages, setLocation, setLocation, setLocationByPlatform, setLocationRelativeTo, setMinimumSize, setModalExclusionType, setOpacity, setShape, setSize, setSize, setType, show, toBack, toFront`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalPolicy, getInsets, getLayout, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resize, resize, revalidate, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setMaximumSize, setName, setPreferredSize, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ColumnChooserSelector

          public ColumnChooserSelector(JComponent parentComponent,
                                       AbstractGanttChart gc)

      Constructs a new column chooser selector.
      Parameters:
        `parentComponent` - the parent component
        `gc` - the Gantt chart that will be controlled by the selector
      Since:
        1.0

  - ### Method Detail

    - #### setVisible

          public void setVisible(boolean b)

      Overrides the method in order to update the two column lists first before proceeding to actually display the selector.
      Overrides:
        `setVisible` in class `Selector`
      Since:
        1.0
      See Also:
        `Selector.setAnimationEnabled(boolean)`, `Selector.setGlobalAnimationEnabled(boolean)`

    - #### mouseClicked

          public void mouseClicked(MouseEvent e)

      Specified by:
        `mouseClicked` in interface `MouseListener`

    - #### mouseEntered

          public void mouseEntered(MouseEvent e)

      Specified by:
        `mouseEntered` in interface `MouseListener`

    - #### mouseExited

          public void mouseExited(MouseEvent e)

      Specified by:
        `mouseExited` in interface `MouseListener`

    - #### mousePressed

          public void mousePressed(MouseEvent e)

      Specified by:
        `mousePressed` in interface `MouseListener`

    - #### mouseReleased

          public void mouseReleased(MouseEvent e)

      Specified by:
        `mouseReleased` in interface `MouseListener`

    - #### mouseDragged

          public void mouseDragged(MouseEvent e)

      Specified by:
        `mouseDragged` in interface `MouseMotionListener`

    - #### mouseMoved

          public void mouseMoved(MouseEvent e)

      Specified by:
        `mouseMoved` in interface `MouseMotionListener`

    - #### getColumnChooser

          public ColumnChooser getColumnChooser()

      Returns the column chooser.
      Returns:
        the column chooser
      Since:
        1.0

    - #### getButtonPanel

          public JPanel getButtonPanel()

      Returns the button panel that contains the close button. The button panel is nested within the footer panel.
      Returns:
        the panel that contains the close button
      Since:
        1.0

    - #### getCloseButton

          public JButton getCloseButton()

      Returns the button for closing the selector.
      Returns:
        the close button
      Since:
        1.0

    - #### getContentPanel

          public JPanel getContentPanel()

      Returns the panel that contains the chooser and the footer.
      Returns:
        the panel and owner of the chooser and footer
      Since:
        1.0

    - #### getResizeIconLabel

          public JLabel getResizeIconLabel()

      Returns the label that is used for resizing the selector.
      Returns:
        the label used for resizing the selector
      Since:
        1.0

Copyright © 2006–2020 Dirk Lemmermann Software & Consulting. All rights reserved.